##


              _   _ _   _ _____  __    ____    ____   ___  
             | | | | \ | |_ _\ \/ /   / __ \  | ___| / _ \ 
             | | | |  \| || | \  /   / / _` | |___ \| | | |
             | |_| | |\  || | /  \  | | (_| |  ___) | |_| |
              \___/|_| \_|___/_/\_\  \ \__,_| |____/ \___/ 
                                      \____/               
             
                 50 years of the Unix Operating System
                   Myths, Legends, and quirky stories
     
                       Vincenzo "KatolaZ" Nicosia
                            Freaknet -- QMUL
     
                            Lovelace Mondays
                            Mon 2nd Dec 2019
     
                Dipartimento di Matematica e Informatica
                       Universita' della Calabria 

##
                              _                         
                             | |_  __ _ _ __ _ __ _  _  
                             | ' \/ _` | '_ \ '_ \ || | 
                             |_||_\__,_| .__/ .__/\_, | 
                     )                 |_|  |_|   |__/  
                    (.)           _    _     _   _       _           
                    .|.          | |__(_)_ _| |_| |_  __| |__ _ _  _ 
                    l8J          | '_ \ | '_|  _| ' \/ _` / _` | || |
                    | |          |_.__/_|_|  \__|_||_\__,_\__,_|\_, |
                _.--| |--._                                     |__/ 
             .-';  ;`-'& ; `&.
            & &  ;  &   ; ;   \       __  ___   _______  __    __
            \      ;    &   &_/      / / / / | / /  _/ |/ /   / /
             F"""---...---"""J      / / / /  |/ // / |   /   / / 
             | | | | | | | | |     / /_/ / /|  // / /   |   /_/  
             J | | | | | | | F     \____/_/ |_/___//_/|_|  (_)   
              `---.|.|.|.---'                                    
                          Krogg

##
              _      _      _      _      _      _      _
           \/'-'\/\/'-'\/\/'-'\/\/'-'\/\/'_'\/\/'-'\/\/'-'\/
            \_;_/  \_;_/  \_;_/  \_;_/  \_;_/  \_;_/  \_;_/
             / \    / \    / \    / \    / \    / \    / \
 
         |_   _    o  _   _|_ |_   _  
    \/\/ | | (_)   | _>    |_ | | (/_ 
          _      _      _      _      _      _      _
       \/'-'\/\/'-'\/\/'-'\/\/'-'\/\/'_'\/\/'-'\/\/'-'\/
        \_;_/  \_;_/  \_;_/  \_;_/  \_;_/  \_;_/  \_;_/
         / \    / \    / \    / \    / \    / \    / \
                                               _  
    |_  o ._ _|_ |_   _|  _.      |_   _        ) 
    |_) | |   |_ | | (_| (_| \/   |_) (_) \/   o  
                             /            /     
              _      _      _      _      _      _      _
           \/'-'\/\/'-'\/\/'-'\/\/'-'\/\/'_'\/\/'-'\/\/'-'\/
            \_;_/  \_;_/  \_;_/  \_;_/  \_;_/  \_;_/  \_;_/
             / \    / \    / \    / \    / \    / \    / \

##
                UNIX: The operating system
                ==========================
         ,_______________________________________,
        /   HHH*                          *HHH   /.
        `---------------------------------------" :
        | +              UNIX (TM)            + | :
        |             .____________.            | :
        |       .++.  |######\  /##|  .++.      | :
        |       +  +  |######/  \##|  +  +      | :
        |       '++'  '------------'  '++'      | :
        |             AT&T BELL LABS            | :
        |           ALL RIGHT RESERVED          | :
        |                                       | :
        |      /'''''''''''''''''''''''''\      I :
        |     /     o       0         o   \     I :
        |+   / O                         O \   +|,'
        `---------------------------------------`
        


##  
                UNIX: The operating system
                ==========================

  - Operating system for mini and micro computers

  - Developed at AT&T Bell Laboratories (1969 - 1992) 

  - Initially working on DEC PDP-11

  - Then ported on Interdata, VAX, m68k, Sparc, Alpha, i386,
    RISC, PPC, ...

  - Licensed to universities and resellers

  ...but...
  
  - Ceased its existence around 1992 (SysV R4.2) 

  - Most of the architectures where it worked are extinct 


##
                 UNIX: The Trademark
                 ===================
      
                                                _______ __  ____  
                                               / /_   _|  \/  \ \ 
      mm    mm  mmm   mm   mmmmmm   mmm  mmm  | |  | | | |\/| || |
      ##    ##  ###   ##   ""##""    ##mm##   | |  |_| |_|  |_|| |
      ##    ##  ##"#  ##     ##       ####     \_\            /_/ 
      ##    ##  ## ## ##     ##        ##                         
      ##    ##  ##  #m##     ##       ####     
      "##mm##"  ##   ###   mm##mm    ##  ##    
        """"    ""   """   """"""   """  """   

##
                 UNIX: The Trademark
                 ===================
      
  - UNIX is a Trademark registered by AT&T

  - when AT&T dismantled the UNIX business the trademark was sold and 
    passed to 

    ...Novell first...
    ...X/Open next... 
    ...and finally to The Open Group

  - The Open Group certifies UNIX(tm)-compliant systems, and licenses
    the usage of the UNIX(tm) trademark (after you have paid $$$)

  - Current Licensees include: AIX (IBM), HP-UK (HP), Solaris (Oracle), 
                               Tru64 (DEC), macOS (Apple) and z/OS (IBM)

  ...but...

  - UNIX is not just about MONEY...

##
           UNIX: The kernel interface
           ==========================

        +------------------------------+
        |                              |
        |             USERS            |
        |                              |
        +------------------------------+
        +--------+ +--------+ +--------+  
        |        | |        | |        |  
        | prog1  | | prog2  | | prog3  |  
        |        | |        | |        |  
        +--------+ +--------+ +--------+  
        +--||----||-----||------||-----+  
        | read  fork  socket  getcwd   |  
        |                              |  
        |             UNIX             |  
        +------------------------------+  
        +------------------------------+  
        |                              |  
        |            HARDWARE          |  
        |                              |  
        +------------------------------+  
## 
           UNIX: The kernel interface
           ==========================

  - A (more or less) defined set of "standard" system calls
    (read, open, creat, fork, ...)

  - A common interface between user programs and hardware
    resources (memory, disks, network, etc.)

  - Common access to data (everything is a file)

  ...but...

  - the set of system calls is not standard
    
     - 35 in the original UNIX - About 350 in modern Linux
       more than 400 in FreeBSD

##
                  UNIX: The Philosophy
                  ====================
                     
                             =O===
                            %- - %%%
                           % <    D%%
                           ' ,  ,$$$
                    /      %%%%  |
                    |//; ,---' _ |----.
                     \ )(           /  )
                     | \/ \.   '  _.|,  \
                     |  \ /(   /    / \_ \
                      \ /  (        | /  )
                           (  ,  ___|/ ,`
                           (   _/ (  |  \_
                         _/\--//     ,\\\
               _______ _/\\   / |      |_________
              |_______/   \\ / _/   ,   |________|
              __|___#/     \  _  '      |##____|___
             /______/ _    |  / \   |   /__________\
                   |   /           _/\_/  b'ger
                   /_     '_,____\/ )(
                  |/ \_   /        (  \
                   | /-\_/          Oooo
                   )(.
                  /  )
                 oooO

##
                  UNIX: The Philosophy
                  ====================

  - KISS: Keep It Simple, Stupid!

  - Do one thing, and do it well

  - Prefer small programs

  - Make programs interact easily (filters and pipes)

  - Use text input/output

  - Prefer portability over efficiency

  - Prototype before polishing

  - If unsure, just shut up

##
                                          ,-._.-._.-._.-._.-.
                                          `-.             ,-'
             .----------------------.       |             |
            |                        |      |             |
            |  If anything of UNIX   |      |             |
            |  has survived to       |      |             |
            |  these days, it must   |     ,';".________.-.
            |  be the UNIX way of    |     ;';_'         )]
            |  doing computing....   |    ;             `-|
            |                        `.    `T-            |
             `----------------------._ \    |             |
                                      `-;   |             |
                                            |..________..-|
                                           /\/ |________..|
                                      ,'`./  >,(           |
                                      \_.-|_/,-/   ii  |   |
                                       `."' `-/  .-"""||    |
                                        /`^"-;   |    ||____|
                                       /     /   `.__/  | ||
                                            /           | ||
                                                        | ||
##
                                            _,-='`~ >
 UNIX:                   _.,_          _,-'`\      >
                     _.-'`-  `'-._,.-'`     /_      > 
   HISTORY     _.-'`` <>-  -<    /       .-'_>       > 
              /~o    ,       \  |      ,'  _  >  -    > 
     MYTH     (.-,   `    _   \_ \     \  _  >  _     > 
                (_,--=--'`  ,`/   \    | _  >         > 
       LEGEND  .-'       _,' /    /    / _ >     -   > 
              /             '    /    / - >         > 
       .-=-. /              ___./   .'  >          > 
      /     Y               ````   /  >          >  
    .' _/\   \                   ,'  >    >   >    ,-===--.
  /`  /   \   `-              ,-`  >   >  ,>_    ,'        `\
  (   >  : \              ..-'   >  > _,>`   `--'            \
   \ / ) L\ \             `\   >_,.--'             ,-'"'\    |
    `-./ (_\ \_____         `-'                  <'    _/    /
      (   :\\.```                                 \ ,-'     /
       `\_;_> `-.-~`'-_             ---._          Y  __,.-'
                       `'-...__  __,.-=- \         \ (_,-':
                             _.`\_      ._>._       `-._='
                            <     `-._   \   `'-._     `;
                            L _<`-.       \       `'-.   \
                            \~ /   `-._  .'           `\  \
                             \/        `'               L  \_
cjr                                                     \   ;`'-.
14jul00                                                  \___\,.


##  
            The Unix epoch
            ==============
        
                _____
             _.'_____`._
           .'.-'  12 `-.`.
          /,' 11      1 `.\
         // 10      /   2 \\     NUMBER OF SECONDS
        ;;         /       ::      
        || 9  ----O      3 ||      SINCE 1st JANUARY 1970
        ::                 ;;  
         \\ 8           4 //            AT MIDNIGHT
          \`. 7       5 ,'/
           '.`-.__6__.-'.'
            ((-._____.-))
            _))       ((_
           '--'SSt    '--'
       


## 
               ~100,000,000 BUE (1967) -- Multics
               ==================================

          MULTIPLEXED INFORMATION AND COMPUTING SERVICE 
     
        MIT      AT&T           __.--'~~~~~`--.
              ..       __.    .-~   T    C S    ~-.
              ((\     /   `}.~    L    I           `.
      GE       \\\  .{     }    U          /     \   \
           (\   \\~~       }   M          |       }   \
            \`.-~ -@~     }  ,-,.         |       )    \
            (___     ) _}  (    :        |    / /      `._
             `----._-~.     _\ \ |_       \   / /-.__     `._
                    ~~----~~  \ \| ~~--~~~(  + /     ~-._    ~-._
                              /  /         \  \          ~--.,___~_-_.
                           __/  /          _\  )
                         .<___.'         .<___/    

## 
       ~ 13,219,200 BUE (July 1969) -- The origin
       ==========================================
      
                 '-.               .-'
           _________'-._________.-'_________     
           |       _    '-. .-'   _        |     
           |      (_)  /      \  (_)       |  
           '-.        /        \        .-'
              '-.____/          \____.-'
                     \_ _ _ _ _ /          K E N 
                 //////////\\\\\\\\\  
                ///////////\\\\\\\\\\  T H O M P S O N
               |||| .-----------._||||
               |||| '-|___|___|-' ||||
               \\\\  '---------'  ////
                 \\\|||||||||||||///
                   \\\\\\\\///////
                     \\\\\\/////         jnh
      
##
            The Mythical Man-Month
            ======================

      - Ken Thompson, Dennis Ritchie, and Rudd Canaday in the same room

      - they discuss a prototype of a hierarchical filesystem

      - Ken implemented the filesystem on a "poorly-used" PDP-7  

      - "At a certain point I realised I was three weeks away 
         from a complete system", Ken

      - Ken's wife goes on vacation to the West Coast

         - One week for the assembler

         - One week for the editor (ed!)

         - One week for the shell (and an exec loop)  

##
    
                                   
                m    m mm   m mmmmm    mmm   mmmm 
                #    # #"m  #   #    m"   " #"   "
                #    # # #m #   #    #      "#mmm 
                #    # #  # #   #    #          "#
                "mmmm" #   ## mm#mm   "mmm" "mmm#"
        ,=""=,   
       c , _,{     UNIPLEXED INFORMATION AND COMPUTING SERVICE
       /\  @ )                 __
      /  ^~~^\          <=.,__/ '}=
     (_/ ,, ,,)          \_ _>_/~
      ~\_(/-\)'-,_,_,_,-'(_)-(_)  -Naughty                                 

## 
            0 UE - 157,680,000 UE (1970 - 1974)
            ===================================

                   __
                 .'  '.
                :      :
                | _  _ |
             .-.|(o)(o)|.-.        _._          _._
            ( ( | .--. | ) )     .',_ '.      .' _,'.
             '-/ (    ) \-'     / /' `\ \ __ / /' `\ \
              /   '--'   \     / /     \.'  './     \ \
              \ `"===="` /     `-`     : _  _ :      `-`
               `\      /'              |(o)(o)|
                 `\  /'                |      |
                 /`-.-`\_             /        \
           _..:;\._/V\_./:;.._       /   .--.   \
         .'/;:;:;\ /^\ /:;:;:\'.     |  (    )  |
        / /;:;:;:;\| |/:;:;:;:\ \    _\  '--'  /__
   jgs / /;:;:;:;:;\_/:;:;:;:;:\ \ .'  '-.__.-'   `-.

                  K E N               D E N N I S 
             T H O M P S O N         R I T C H I E 

## 
                1970: "No operating systems research!"
                ======================================

  
         - the PDP-7 was already obsolete in 1969

         - The new PDP-11/20 from DEC was just perfect for UNICS

         - AT&T did not want to spend ANY MONEY AT ALL on Operating Systems 

         - They got a PDP-11/20 to produce a text-processing system! 

         - UNIX was immediately ported on the PDP-11/20

##
           1972: "C is not a very high-level language"
           ===========================================
                       _____ _        
                      |_   _| |_  ___ 
                        | | | ' \/ -_)
                        |_| |_||_\___|
                             mmmm  
                           ##""""# 
                          ##"      
                          ##       
                          ##m      
                           ##mmmm# 
                             """"  
       _ __ _ _ ___  __ _ _ _ __ _ _ __  _ __ (_)_ _  __ _ 
      | '_ \ '_/ _ \/ _` | '_/ _` | '  \| '  \| | ' \/ _` |
      | .__/_| \___/\__, |_| \__,_|_|_|_|_|_|_|_|_||_\__, |
      |_|           |___/                            |___/ 
                _                                   
               | |__ _ _ _  __ _ _  _ __ _ __ _ ___ 
               | / _` | ' \/ _` | || / _` / _` / -_)
               |_\__,_|_||_\__, |\_,_\__,_\__, \___|
                           |___/          |___/     
##
          QUIZ: What is the most powerful ASCII character? 
          ================================================ 




          or: How to totally break Unix with the minimal 
                        possible effort?
               
                                            \         .  ./
                                          \      .:";'.:.."   /
                                              (M^^.^~~:.'").
                                        -   (/  .    . . \ \)  -
                 O                         ((| :. ~ ^  :. .|))
                |\\                     -   (\- |  \ /  |  /)  -
                |  T                         -\  \     /  /-
               / \[_]..........................\  \   /  /

##
          QUIZ: What is the most powerful ASCII character? 
          ================================================ 



                                  +--+  
                                  |  |   
                                  |  | 
      The winner is:  pipe!       |  |     (0174 / 124 / 0x7C)
                                  |  | 
                                  |  |   
                                  +--+ 

##

                                
                                           .--'''''''''--.
    "We should have some ways           .'      .---.      '.
     of coupling programs like         /    .-----------.    \
     garden hose --screw in another   /        .-----.        \
     segment when it becomes          |       .-.   .-.       |
     necessary to massage data        |      /   \ /   \      |
     in another way. This is the       \    | .-. | .-. |    /
     way of IO also."                   '-._| | | | | | |_.-'
                                            | '-' | '-' |
            Doug McIlroy, 1964               \___/ \___/
                                          _.-'  /   \  `-._
                                        .' _.--|     |--._ '.
                                        ' _...-|     |-..._ '
                                               |     |
                                               '.___.'
                                                 | |

##
                                                      .-----.   ()()
      "He [Ken] added a pipe system call [...]       /       \ .'()
       in one hour [...] [then] added the pipe       |__...__|/
       mechanism to the shell, tried it out,         |_....._|
       and called the result MIND-BLOWING..."      .-'  ___  '-.
                                                   \_.-`. .`-._/
       Brian Kernighan       __ .--. _              (|\ (_) /|)
                          .-;.-"-.-;`_;-,            ( \_=_/ )
                        .(_( `)-;___),-;_),          _(_   _)_
                       (.( `\.-._)-.(   ). )       /` ||'-'|| `\
                     ,(_`'--;.__\  _).;--'`_)  _  /_/ (_>o<_) \_\
                    // )`--..__ ``` _( o )'(';,)\_//| || : || |\\
                    \;'        `````  `\\   '.\\--' |`"""""""`|//
                    /                   ':.___//     \___,___/\_(
                   |                      '---'|      |__|__|
                   ;                           ;      ;""|"";
                    \                         /       [] | []
                     '.                     .'      .'  / \  '.
                    jgs'-,.__         __.,-'        `--'   `--'
                        (___/`````````\___) 
##
           Communications of the ACM, 17(7), 1974
           ======================================

   The UNIX Time-
   Sharing System

   Dennis M. Ritchie and Ken Thompson
   Bell Laboratories

   
     UNIX is a general-purpose, multi-user, interactive
   operating system for the Digital Equipment Corpora-
   tions PDP-11/40 and 11/45 computers. It offers a number
   of features seldom found even in larger operating sys-
   tems, including:....

## 





               "Perhaps I didn't do a good job", Ken
               =====================================





##

               $$$$$$$$$$$$$$$$$$$$$$$$$
               $$$$$$$$$$$$$$$$$$$$$$$$$
               $$$$$'`$$$$$$$$$$$$$'`$$$
               $$$$$$  $$$$$$$$$$$  $$$$
               $$$$$$$  '$/ `/ `$' .$$$$
               $$$$$$$$. i  i  /! .$$$$$
               $$$$$$$$$.--'--'   $$$$$$
               $$^^$$$$$'        J$$$$$$
               $$$   ~""   `.   .$$$$$$$
               $$$$$e,      ;  .$$$$$$$$
               $$$$$$$$$$$.'   $$$$$$$$$
               $$$$$$$$$$$$.    $$$$$$$$
               $$$$$$$$$$$$$     $by&TL$
               -------------------------
                      WE LOVE UNIX 
               -------------------------

##
                1974: "Love, Ken" 
                =================

  - UNIX is shipped to Universities for 150$         ,-""-.  .-""-.
                                                    /   -. \/   -. \
                                                   (                )
  - Full sources are available for little more $$$  \              /
                                                     \            /
                                                      `.        ,'
                                                        `.    ,'  hjw
  - You receive a 9-track tape with a message:            `.,'
                                                   ,-"-,-"-.
                     "Love, Ken"                  (         )
                                                   ".     ."
                                                     "._." 
  - Many US universities run unix by the end of 1974        _  _
     (including UC Berkeley...)                            ( `' )
                                                            `.,'

## 
             Bell Systems UNIX(tm) support policy:
             =====================================


        
            *======================================*
            ;                                      ;
            ;   o No Advertisement                 ;
            ;                                      ;
            ;   o No Support                       ;
            ;                                      ;
            ;   o No Bug-fixes                     ;
            ;                                      ;
            ;   o Payment in advance               ;
            ;                                      ;
            *======================================*

##
                                             ___A___
                                            /   |   \
                                           / __ | __ \
    "What we wanted to preserve            |/ o\_/o \|
     was not just a good                   (.--(_)--.)
     environment in which to do        .===/.-'\_/`-.\===.
     programming, but a system       .'\  /           \ / `.
     around which fellowship       /___ |_\           /_|___\_
     could form".                 <____>'\ `.       ,' /`<____>
                                  /   /   >==`-._.-'==<  /   /
            Dennis Ritchie      _/==='   /  ,---:---.  \/==,'
                               / _ /     |__/v^v^v^v^v\__)  \
                               \)|)      |V^V^V^V^V^V^V|\__/
                                ||        \`-----|-----'/
                                ||         \--.__|__,--/
                                ||          |____|____|
                                ||         <_____X_____>
                             /A || A\       \....|..../
                            // \||/ \\       \   |   /
                           ((   []   ))      / v | v \
                            \\ /  \ //      /   ,^    \
                             \V    V/       `--'   `--'  hjw/Zot
##
                   A FELLOWSHIP OF UNIX USERS
		   ==========================

              
                                                        
               m    m  mmmm  mmmmmm mm   m mmmmm  m    m
               #    # #"   " #      #"m  #   #     #  # 
               #    # "#mmm  #mmmmm # #m #   #      ##  
               #    #     "# #      #  # #   #     m""m 
               "mmmm" "mmm#" #mmmmm #   ## mm#mm  m"  "m
                                                        

##
         157,680,000 UE - 315,360,000 UE (1975 - 1979)
         =============================================



      +-----+ +------+ +------+ +------+ +------+ +------+
      |UNICS|-|UNIXv1|-|UNIXv2|-|UNIXv3|-|UNIXv4|-|UNIXv5|
      +-----+ +------+ +------+ +------+ +------+ +------+
       1969     1971     1972     1973     1973     1974



     +------+                                     +------+
     |UNIXv6|-------------------------------------|UNIXv7|
     +------+                                     +------+
       1975                                         1979

##
        UNIX v7: The grandparent of all Unix-like systems
	=================================================
                                        
                                                      ,-----.
    ar at awk basename bc cc cal cat                W/,-. ,-.\W
    cd chmod chown cmp comm cp date                 ()>a   a<()
    dd df diff du echo ed expr false                (.--(_)--.)
    file find fgrep grep join kill                ,'/.-'\_/`-.\`.
    lex link ln ls mailx man mesg               ,' /    `-'    \ `.
    mkdir mv newgrp nice nm nohup od           /   \           /   \
    pr ps pwd rm rmdir sed sh slip            /     `.       ,'     \
    sort split strip stty tee test           /    /   `-._.-'   \    \
    time touch tr true tsort tty           ,-`-._/|     |=|o    |\_.-<
    uniq unlink uucp uux wait wc          <,--.)  |_____| |o____|  )_ \
    who write                              `-)|    |//   _   \\|     )/
                                             ||    |'    |    `|
                                             ||    |     |     |
                                             ||    (    )|(    )
                                             ||    |     |     |
                                             ||    |     |     |
                                             ||    |_.--.|.--._|
                                             ||     /'""| |""`\
                                             []     `===' `==='  hjw
                                        
##
          ___                      ___                      ___                        
      _.-'   \                 _.-'   \                 _.-'   \                      
     /        \               /        \               /        \                     
    /     A    \             /     W    \             /     K    \                    
   /            `.___       /            `.___       /            `.___               
  ( .--.)\/(,.--.    `-.   ( .--.)\/(,.--.    `-.   ( .--.)\/(,.--.    `-.            
  ,',-. \   / ,-.`.     )  ,',-. \   / ,-.`.     )  ,',-. \   / ,-.`.     )     
 ( /   \     /   \ )   /  ( /   \     /   \ )   /  ( /   \     /   \ )   /      
  || .-|     |-. ||---'    || .-|     |-. ||---'    || .-|     |-. ||---' 
 _|| | |     | | ||_      _|| | |     | | ||_      _|| | |     | | ||_    
/. \ |_|.---.|_| / ,\    /. \ |_|.---.|_| / ,\    /. \ |_|.---.|_| / ,\   
`.\ `--"     "--' /,'    `.\ `--"     "--' /,'    `.\ `--"     "--' /,'  
  `>  _________ <'         `>  _________ <'         `>  _________ <'                  
,-' ,---.---.---. `-.    ,-' ,---.---.---. `-.    ,-' ,---.---.---. `-.               
`--'\    \j/    /`--'    `--'\    \j/    /`--'    `--'\    \j/    /`--'               
   `.\         /,'          `.\         /,'          `.\         /,'                  
     \\_______//              \\_______//              \\_______//                    
      `-------'                `-------'                `-------'       hjw           
     A L F R E D               P E T E R                B R I A N
         AHO                  WEINGERGER                KERNIGHAN
    (regexp,egrep,..)            (f77)               (troff,eqn,m4...)
##


            ___              |\            .---.             _
           ( o )            |'_\           \ V /            | |
           _| |_           _| |_           _| |_           _| |_
         .`_____`.       .`_____`.       .`_____`.       .`_____`.
       |\ /     \ /|   |\ /     \ /|   |\ /     \ /|   |\ /     \ /|
       |||  @ @  |||   |||  9 9  |||   |||  6 6  |||   |||  o o  |||
       \_\   =   /_/   \_\   -   /_/   \_\   o   /_/   \_\  ._.  /_/
        .-'-----'-.     .-'-----'-.     .-'-----'-.     .-'-----'-.
       (_   ___   _)   (_   ___   _)   (_   ___   _)   (_   ___   _)
         | |___| |       | |___| |       | |___| |       | |___| |
         |       |       |       |       |       |       |       |
         (___|___)       (___|___)       (___|___)       (___|___)
           J O E           S T U          D O U G          L E E
          OSSANA          FELDMAN         MCILROY         MCMAHON

          (troff)          (make)     (diff,join,sort)     (sed)
##

              _          __________                              _,
          _.-(_)._     ."          ".      .--""--.          _.-{__}-._
        .'________'.   | .--------. |    .'        '.      .:-'`____`'-:.
       [____________] /` |________| `\  /   .'``'.   \    /_.-"`_  _`"-._\
       /  / .\/. \  \|  / / .\/. \ \  ||  .'/.\/.\'.  |  /`   / .\/. \   `\
       |  \__/\__/  |\_/  \__/\__/  \_/|  : |_/\_| ;  |  |    \__/\__/    |
       \            /  \            /   \ '.\    /.' / .-\                >/-.
       /'._  --  _.'\  /'._  --  _.'\   /'. `'--'` .'\/   '._-.__--__.-_.'
     \/_   `""""`   _\/_   `""""`   _\ /_  `-./\.-'  _\'.    `""""""""`'`\
     (__/    '|    \ _)_|           |_)_/            \__)|        '
       |_____'|_____|   \__________/|;                  `_________'________`;-'
       s'----------'    '----------'   '--------------'`--------------------`
         S T E V E        S T E V E      L O R I N D A         M I K E     
           BOURNE          JOHNSON          CHERRY              LESK

          (shell)       (pcc,yacc,lint)   (eqn,bc,dc)       (lex,tbl,uucp)
## 
               UNIX V6 everywhere
                     ,_   .  ._. _.  .        _  ,   .
                 , _-\','|~\~~ ~~ ~~/       ;-'-'  ~-',    ,;_;_,    ~~-
        /~~-\_/-'~'--' \~~| \,/' _-|       /  /  |_/~-/-/~~      ~~--~~~~'---_
        /              ,/'-/~ '\./   '  , '|,'|~   '                ._/-, /~~
        ~/-'~\_,       '-,| '|. '       X\ /'~                 /    /_  /~
      .-~      '|      XX'',\~|\        _\X     ,_ .  .              /|
                '\XXX   XX/'~           |_/~\\,-,~' \ "          ,_,/ X
                 |XXX X X/  .           _-~'\_ _~|               \ ) X
                  \XX __-\            ./      ~ |\  \_           /  ~
        .,         '\ |,  ~-_       . |          \\_' ~|  /~\  \~ ,
                     ~-_'    ;        \           '-,   \,'  /\/  |
 - US and Canada       '\_,~'\_        \_ _,       /'    '   |, /|'
                         /     \_        ~ |      /          \  ~'; -,_.
 - Europe                |       ~\         |    |  ,         '-_, ,; ~ ~\
    (KU AMS, QMC)         \,      /         \    / /|             ,-, ,   -,
                           |    ,/           |  |' |/           ,-   ~ \   '.
 - Japan                  ,|   ,/            \ ,/               \       |
                          /    |              ~                  -~~-,X/   _
 - Australia              |  ,-'                                      ~    /
    (UNSW, Wollongong)    / ,'                                        ~
                          ',|  ~

## 
       _                                _                 
      /_\    __ ___ _ __  _ __  ___ _ _| |_ __ _ _ _ _  _ 
     / _ \  / _/ _ \ '  \| '  \/ -_) ' \  _/ _` | '_| || |
    /_/ \_\ \__\___/_|_|_|_|_|_\___|_||_\__\__,_|_|  \_, |
                                                     |__/ 
                _   _          _   _ _  _ _____  __
     ___ _ _   | |_| |_  ___  | | | | \| |_ _\ \/ /
    / _ \ ' \  |  _| ' \/ -_) | |_| | .` || | >  < 
    \___/_||_|  \__|_||_\___|  \___/|_|\_|___/_/\_\
                            _   _           
     ___ _ __  ___ _ _ __ _| |_(_)_ _  __ _ 
    / _ \ '_ \/ -_) '_/ _` |  _| | ' \/ _` |
    \___/ .__/\___|_| \__,_|\__|_|_||_\__, |
        |_|                           |___/ 
                _             
     ____  _ __| |_ ___ _ __  
    (_-< || (_-<  _/ -_) '  \ 
    /__/\_, /__/\__\___|_|_|_|       
        |__/         

           (c) 1976 JOHN LIONS (UNSW)

##
         "You are not expected to understand this"
         =========================================      

        /*  
         * Switch to stack of the new process and set up
         * his segmentation registers.
         */  
        retu(rp->p_addr);
        sureg();
        /*  
         * If the new process paused because it was 
         * swapped out, set the stack level to the last call
         * to savu(u_ssav).  This means that the return
         * which is executed immediately after the call to aretu
         * actually returns from the last routine which did 
         * the savu.
         *   
         * You are not expected to understand this.
         */  

##

                 New licensing terms for V7            _____
                                                    .-" .-. "-.
                                                  _/ '=(0.0)=' \_
                 Lions' "commentary" became     /`   .='|m|'=.   `\
                 illegal overnight.             \________________ /
                                            .--.__///`'-,__~\\\\~`
                 Users continued           / /6|__\// a (__)-\\\\
                 photocopying it for       \ \/--`((   ._\   ,)))
                 years.                    /  \\  ))\  -==-  (O)(
                                          /    )\((((\   .  /)))))
                 It is considered        /  _.' /  __(`~~~~`)__     jgs
                 the most photocopied   //"\\,-'-"`   `~~~~\\~~`"-.
                 book of the whole     //  /`"              `      `\
                 history of           //
                 computer science.
              
##
                                  
                                    
                                           ,---,_          ,
  "This is the Unix philosophy.             _>   `'-.  .--'/
   Write programs that do one thing     .--'` ._      `/   <_
   and to it well. Write programs       >,-' ._'.. ..__ . ' '-.
   to work together. Write programs  .-'   .'`         `'.     '.
   that handle text streams,          >   / >`-.     .-'< \ , '._\
   because this is a universal       /    ; '-._>   <_.-' ;  '._>
   interface".                       `>  ,/  /___\ /___\  \_  /
                                     `.-|(|  \o_/  \o_/   |)|`
           Doug McIlroy            jgs   \;        \      ;/
                                           \  .-,   )-.  /
                                            /`  .'-'.  `\
                                           ;_.-`.___.'-.;


##
          315,360,000 UE - 473,040,000 UE (1980 - 1984)
          =============================================
                      __                                        __ 
                     |--|                                      |--|
          .._       o' o'                     (())))     _    o' o'
         //\\\    |  __                      )) _ _))  ,' ; |  __  
        ((-.-\)  o' |--|  ,;::::;.          (C    )   / /^ o' |--| 
       _))'='(\-.  o' o' ,:;;;;;::.         )\   -'( / /     o' o'
      (          \       :' o o `::       ,-)()  /_.')/                 .
      | | .)(. |\ \      (  (_    )      /  (  `'  /\_)    .:izf:,_  .  |
      | | _   _| \ \     :| ,==. |:     /  ,   _  / 1  \ .:q568Glip-, \ |
      \ \/ '-' (__\_\____::\`--'/::    /  /   / \/ /|\  \-38'^"^`8k='  \L,
       \__\\[][]____(_\_|::,`--',::   /  /   /__/ <(  \  \8) o o 18-'_ ( /
        :\o*.-.(     '-,':   _    :`.|  L----' _)/ ))-..__)(  J  498:- /]
        :   [   \     |     |=|   '  |\_____|,/.' //.   -38, 7~ P88;-'/ /
        :  | \   \    |  |  |_|   |  |    ||  :: (( :   :  ,`""'`-._,' /
        :  |  \   \   ;  |   |    |  |    \ \_::_)) |  :  ,     ,_    /
        :( |   /  )) /  /|   |    |  |    |    [    |   \_\      _;--==--._ 
     MJP:  |  /  /  /  / |   |    |  |    |    Y    |CJR (_\____:_        _:
        :  | /  / _/  /  \   |lf  |  |  CJ|mk  |    | ,--==--.  |_`--==--'_|
                                                              "   `--==--'  

## 
                 The Berkeley System Distribution
                 ================================

       - UNIX (v4) arrived at UC Berkeley in 1974

       - Grad students started "playing with it"

       - Bill Joy and Chuck Haley (re)wrote a Pascal compiler

       - Joy wrote the "ex" editor

       - Universities wanted a Pascal compiler

       - Joy put together the compiler and ex and created 1BSD (1978)

##
      +----------+
      |UNIX v5-v6|
      +---+------+          +----+
          +---------------->|1BSD|    (1978 - PDP-11)
      +--------+            +-+--+
      |UNIX 32V|              |   
      +---+----+            +-v--+
          |                 |2BSD|    (1979 - PDP-11)
          |                 +-+--+
          |                   |
          |                 +-v--+
          +---------------->|3BSD+-+      (1980 - VAX)
                            +----+ |
                                   v
                            +-------+
                            |BSD 4.0+------+    (1981 - VAX)
                            +-------+      v
                                       +-------+           (1981 - VAX)
                                       |BSD 4.1+-------+
                                       +-------+       v
                                                   +-------+
                                                   |BSD 4.2|    (1983 - VAX)
                                                   +-------+

##





                                                      
                 mmm       mmmm      mmmm     mmmmm   
                #"##     m##""##m  m##""##m  #""""##m 
                  ##     ##    ##  ##m  m##       m## 
                  ##     "##mm###   ######     #####  
                  ##       """ ##  ##"  "##       "## 
               mmm##mmm   #mmm##   "##mm##"  #mmmm##" 
               """"""""    """"      """"     """""   

##





                                                                      
 mmmmmm      mmmm    mmmmm                   mmm              mmmmm   
 ##""""##  m#""""#   ##"""##                m###             #""""##m 
 ##    ##  ##m       ##    ##              #" ##                   ## 
 #######    "####m   ##    ##            m#"  ##                 m#"  
 ##    ##       "##  ##    ##            ########              m#"    
 ##mmmm##  #mmmmm#"  ##mmm##                  ##      ##     m##mmmmm 
 """""""    """""    """""                    ""      ""     """""""" 
                                                                      



##





                                                              
         m   m     m   m   mmmmmmm mmmmmm m    m        m    m
       m"#"m  "m m"  m"#"m    #    #      ##  ##        "m  m"
       #m#     "#"   #m#      #    #mmmmm # ## #         #  # 
         #"#    #      #"#    #    #      # "" #         "mm" 
       "m#m"    #    "m#m"    #    #mmmmm #    #          ##  
         #             #                                      
                                                        

##

    _-`````-,           ,- '- .
  .'   .- - |          | - -.  `. 
 /.'  /                     `.   \
:/   :      _...   ..._      ``   :
::   :     /._ .`:'_.._\.    ||   :   GGGG  N   N  U   U     I   SSS
::    `._ ./  ,`  :    \ . _.''   .   G     NN  N  U   U     I  SS
`:.      /   |  -.  \-. \\_      /    G  G  N N N  U   U     I    SS
  \:._ _/  .'   .@)  \@) ` `\ ,.'     GGGG  N  NN   UUU      I  SSSS  
     _/,--'       .- .\,-.`--`.
       ,'/''     (( \ `  )            N   N   OO   TTTTT
        /'/'  \    `-'  (             NN  N  O  O    T
         '/''  `._,-----'             N N N  O  O    T
          ''/'    .,---'              N  NN   OO     T
           ''/'      ;:
             ''/''  ''/
               ''/''/''               U   U  N   N   I   X  X
                 '/'/'                U   U  NN  N   I    XX
Vijay Kumar       `;                  U   U  N N N   I    XX
                                       UUU   N  NN   I   X  X


## 
             473,040,000 UE - 670,720,000 UE (1985 - 1989)
             =============================================


                          UNIX GOES TO WAR
  

            
            UNIX                                       UNIX
                                             _,.          ___.    .
           ____        ,._               --=:_ *: ======((|_L]_   \\
         c:____]((=-  :* _:=- - - - -         `'       (__(____)   \\   UNIX
          / //   ___   `' ,._                        UNIX           \\___.
         / //  _/_/_]=== :* _:=--          ,.          ___.        _((|_L]_
       _/ //_.(_(_)(_)..  `'           --=: *: ======((|_L]_     _/(__(\_ _)\_
      /____\_\  UNIX    `....              `'       (__(____)
      
      cjr
##
1BSD|2BSD|386 BSD|3BSD|4.4BSD Lite 1|4.4BSD Lite 2|4BSD|A/UX|ABCenix|ACIX|AD|AIX
|AIX PS/2|AIX/370|AIX/6000|AIX/ESA|AIX/RT|AMiX|ANALIX|AOS Lite|AOS Reno|ARIX|ASV
|Acorn RISC Unix|Acorn RISC iX|Altos System V|Android|AppleTV|ArchBSD|Atari Unix
|AurOS|BBX|BKUNIX|BOS|BOS/X|BRL Unix|BS2000/OSD-BC|BSD Net/1|BSD Net/2|BSD/386|B
SD/OS|Bitrig|C Executive|CB Unix|CLIX|COSIX|CPIX|CTIX|CX/UX|CXOs|Chorus|Chorus/M
iX|Coherent|Concentrix|Consensys Unix|ConvexOS|Cromix|DC/OSx|DCC-IX|DEC OSF/1 AC
P|DG/UX|DISTRIX|DNIX|DRM System|DTIX|DVIX|Darwin|Debian GNU/Hurd|Dell Unix|Deskt
opBSD|Digital Unix|Domain/OS|DragonFly BSD|Dynix|Dynix/ptx|EDIX|ENIX|EP/IX|Esix 
SVR4|Eunice|Eurix|FOR:PRO|FTX|FireFly BSD|FreeBSD|FreeDarwin|FreeMiNT|GNU|GNU-Da
rwin|Genix|Gnuppix GNU/Hurd-L4|HCR|HEP-UPX|HI-UX|HP-UX|HP-UX BLS|HPBSD|Helios|IB
M AOS|IBM IX/370|IDRIS|INOS|IRIS GL2|IRIX|Illumos|Inferno|Interactive 386/ix|Int
eractive IS|Junos OS|LSX|LSX|Linux|Lites|LynxOS|MAXION/OS|MCS|MERT|MIPS OS RISC/
os|MMOS|MP-RAS UNIX|MST UNIX|MVS/ESA OpenEdition|MacMach|Mach|MachTen|MicroBSD|M
icroPort Unix|Micronix|Microport SVR4|MidnightBSD|Mimos|Mini Unix|Minix|Minix-VM
D|MirBSD|Mk Linux|Monterey|Mulplix|Munix|NCR Unix/NS |NDIX|NUXI|NachOS|NeXTSTEP|
NetBSD|News-OS|NonStop-UX|ONIX|OPENSTEP|OPUS|OS 9|OS X|OS/390 OpenEdition|OS/390
 Unix|OS/MP|OSF/1|OSx|Oasis|Open Desktop|Open UNIX|OpenBSD|OpenDarwin|OpenIndian
a|OpenServer|OpenSolaris|PC-BSD|PC/IX|PCUNIX|PNX|PWB|PWB/UNIX|PacBSD|Plan 9|Plur
ix|Punix|PureDarwin|QNIX|QNX|QNX RTOS|QNX/Neutrino|QUNIX|REAL|RISC iX|RT|RT/EMT|
RTUX|Regulus|ReliantUnix|RetroBSD|Rhapsody|SCO UNIX|SCO UnixWare|SCO Xenix|SCO X
enix System V/386|SORIX|SOX|SPIX|SPP-UX|SUNIX|Security-Enhanced Linux|Silver OS|
Sinix|Sinix ReliantUnix|Solaris|Sortix|Sphinx|Stellix|SunOS|Super-UX|System B|TI
 System V|TNIX|TOS|TS|Thix|Topix|Triance OS|Tribblix|Tropix|Tru64 Unix|Trusted I
RIX/B|Trusted Solaris|Trusted Xenix|Tunis|UCLA Locus|UCLA Secure Unix|UHC Unix|U
NICS|UNIX 32V|UNIX Interactive|UNIX System III|UNIX System IV|UNIX System V|UNIX
 System V Release 2|UNIX System V Release 3|UNIX System V Release 4|UNIX System 
V/286|UNIX System V/386|UNIX Time-Sharing System|UNOS|UNSW|USG|USIX|UTEK|UTS|UTX
/32S|UX|UXP/DS|UZIX|Ultrix|Ultrix 32M|Ultrix-11|Umax|UniFLEX|UniSoft UniPlus|Uni
cos|Unicos/mk|Unicos/mp|Unicox-max|Uniq|Unisis|Unity|UnixWare|VM/IX|VOLVIX|Venix
|Xenix OS|Xinu|Xoftnix|Zeus|ekkoBSD|iOS|iPhone OS|iPod OS|macOS (Mac OS X)|more/
BSD|mt Xinu|xMach|z/OS Unix System Services|ÆrieBSD|

##
  


 
         Which UNIX sold the largest number of licenses?
         ===============================================      


##


             m    m mmmmmm mm   m mmmmm  m    m
              #  #  #      #"m  #   #     #  # 
               ##   #mmmmm # #m #   #      ##  
              m""m  #      #  # #   #     m""m 
             m"  "m #mmmmm #   ## mm#mm  m"  "m
                                               
                                   
        ___           __  __ _                     __ _ __  
       / / |__ _  _  |  \/  (_)__ _ _ ___ ___ ___ / _| |\ \ 
      | || '_ \ || | | |\/| | / _| '_/ _ (_-</ _ \  _|  _| |
      | ||_.__/\_, | |_|  |_|_\__|_| \___/__/\___/_|  \__| |
       \_\     |__/                                     /_/ 

##



            .xxxx.   
            |    |           m    m mmmmm  mm   m mmmmm  m    m
           |(o)(o)|          ##  ##   #    #"m  #   #     #  # 
          (  (__)  )         # ## #   #    # #m #   #      ##  
            | __ |           # "" #   #    #  # #   #     m""m 
             \__/            #    # mm#mm  #   ## mm#mm  m"  "m
          A N D R E W                               (1987)
           TANENBAUM 

##


                                                               
 mmmmm   mmmm  mmmm          mm   m          m         m mmm   
 #    # #"   " #   "m        #"m  #  mmm   mm#mm      #    #   
 #mmmm" "#mmm  #    #        # #m # #"  #    #       #     #   
 #    #     "# #    #        #  # # #""""    #      #      #   
 #mmmm" "mmm#" #mmm"         #   ## "#mm"    "mm   #     mm#mm 
                                                    (1989)           


##
   670,720,000 UE - 788,400,000 UE (1990 - 1994)
   =============================================
                                                 ,        ,         
                                                /(        )`        
             ,        ,                         \ \___   / |        
            a8888b.                             /- _  `-/  '        
           d888888b.                           (/\/ \ \   /\        
           8P"YP"Y88                           / /   | `    \       
           8|o||o|88                           O O   ) /    |       
           8'    .88                           `-^--'`<     '       
           8`._.' Y8.                         (_.)  _  )   /        
          d/      `8b.                         `.___/`    /         
         dP   .    Y8b.                          `-----' /          
        d8:'  "  `::88b             <----.     __ / __   \          
       d8"         'Y88b            <----|====O)))==) \) /====      
      :8P    '      :888            <----'    `--' `.__,' \         
       8a.   :     _a88P                         |        |         
     ._/"Yaa_:   .| 88P|                          \       /         
jgs  \    YP"    `| 8P  `.                   ______( (_  / \______  
a:f  /     \.___.d|    .'           (FL)   ,'  ,-----'   |        \ 
     `--..__)8888P`._.'                    `--{__________)        \/

##
Date: 25 Aug 91 20:57:08 GMT

Hello everybody out there using minix -

I'm doing a (free) operating system (just a hobby, won't be big and
professional like gnu) for 386(486) AT clones.  This has been brewing
since april, and is starting to get ready.  I'd like any feedback on
things people like/dislike in minix, as my OS resembles it somewhat
(same physical layout of the file-system (due to practical reasons)
among other things). 

I've currently ported bash(1.08) and gcc(1.40), and things seem to work. 
This implies that I'll get something practical within a few months, and
I'd like to know what features most people would want.  Any suggestions
are welcome, but I won't promise I'll implement them :-)

  Linus (torv...@kruuna.helsinki.fi)

PS.  Yes - it's free of any minix code, and it has a multi-threaded fs. 
It is NOT protable (uses 386 task switching etc), and it probably never
will support anything other than AT-harddisks, as that's all I have :-(. 

##



                                                               
 mmmmm   mmmm  mmmm          mm   m          m         m  mmmm 
 #    # #"   " #   "m        #"m  #  mmm   mm#mm      #  "   "#
 #mmmm" "#mmm  #    #        # #m # #"  #    #       #       m"
 #    #     "# #    #        #  # # #""""    #      #      m"  
 #mmmm" "mmm#" #mmm"         #   ## "#mm"    "mm   #     m#mmmm
                                                  "     (1991)       
                                                               


##
         From Jolix to the modern BSD
         ============================


     - in 1992 Bill and Lynn Jolitz ported BSD Net/2 to 80386

     - this required to modify/rewrite about 10 files

     - the new OS was called 386BSD (or Jolix)

     - very slow development

     - a group of users/developers branched out and created FreeBSD (Jun 1993)

     - another group of users/developers forked NetBSD (Apr 1993)

     - in 1994 Theo de Raadt leaves NetBSD and creates OpenBSD

##
   788,400,000 UE - 1,575,309,000 UE (1995 - 2019)
   ==============================================

   - Unix (in its many incarnations) has come to:

     - Smartphones/tablets (97%, Android, iOS)

     - Internet servers (98%)

     - Mainframes (90%-98%)

     - Supercomputers (100% top-500)

     - Embedded (> 35%)

     - Desktop (~12%, incl. MacOS) 

##
            The Unixes of today
            ===================

     - Linux (and its many distributions)

     - FreeBSD, NetBSD, OpenBSD (and clones/forks)

     - AIX (IBM)

     - Solaris (SUN/Oracle)

     - HP-UX

     - MINIX

     - OpenIndiana

     - GNU/Hurd

     - Android

     - MacOS / iOS

## 

                       . 
 
                        . 
              /^\     .   "I think the Linux phenomenon is quite delightful,  
         /\   "V"       .  because it draws so strongly on the basis that Unix  
        /__\   I      O    provided. Linux seems to be the among the healthiest 
       //..\\  I     .     of the direct Unix derivatives, though there are also  
       \].`[/  I       o   the various BSD systems as well as the more official  
       /l\/j\  (]    .  O  offerings from the workstation and mainframe  
      /. ~~ ,\/I         . manufacturers." 
      \\L__j^\/I       o       
       \/--v}  I     o   .           Dennis Ritchie, 1999  
       |    |  I   _________ 
       |    |  I c(`       ')o 
       |    l  I   \.     ,/ 
     _/j  L l\_!  _//^---^\\_    -Row 
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
  
##

              \  |  / ,           ,-`````````'-.
            `-.\ | /,'           /              `. `. \ |  / ,'
           ----     ---         /    _,---''''--.,|  `.\| /,'
            --,     `-.         |   |. __   . __,(| ---     ---
            ,' /_\\_\_          |   | '_@`   `.@`|/   /    `.
                \  \  `._       |() |,        `. \  /` ,| \  `.
                 \    -' `-.__  \__/ `,  .  _   )|/' \/ |  \
                  `.      -'  `--,/|  '`-'`'_`''-|    \
                    `-._           `|     {`-`}  \     \
                        `-._        \,     ``'  |` ,---'
                            `-.       |         \,-'
  "Those who do not            |\     `\         \
   understand Unix are         \ `      \,       \
   condemned to reinvent it,   /          \     |`
   poorly".                   |            \,  / \
                              /              `'  |
         Henry Spencer        |                  |
                              /                  |
                             /      _ __    ,   ,'___,
                            /  _   ' /,-`--'/  ' /   /    Zeus
                            `-' `--..'-----'----'---'

##
        


 
       _____ _                 _                ____  
      |_   _| |__   __ _ _ __ | | _____     _  |  _ \ 
        | | | '_ \ / _` | '_ \| |/ / __|   (_) | |_) |
        | | | | | | (_| | | | |   <\__ \    _  |  __/ 
        |_| |_| |_|\__,_|_| |_|_|\_\___/   ( ) |_|    
                                           |/  





       DISCLAIMER: NO ASCII CHARACTER WAS HARMED DURING THE 
                   PREPARATION OF THIS PRESENTATION

       NOTE: ASCII ARTS BELONG TO THEIR RESPECTIVE AUTHORS.
             IF NO AUTHOR IS INDICATED, THE PIECE IS MINE, 
             AND YOU CAN DO WHATEVER YOU WANT WITH IT.
##
                    REFERENCES
                    ==========

  - D. Rithie, K, Thompson, The Unix Time-Sharing System, CACM 1974

  - P. H. Salus, A quarter century of Unix, 1994

  - P. H. Salus, C. J. Reed, The Demon, The Gnu, and The Penguin,
    2008

  - B. Kernighan, Unix: a history and a memoir, 2019

  - M. D. McIlroy, A Research Unix Reader, 1987

  - G. Brown, Unix: an oral history, 1989

  - I. Darwin, G. Collyer, History of Unix before Berkeley, 1984

  - S. J. Leffler, M. K. McKusick, M. J. Karels, J. S. Quarterman
    The design and implementation of the 4.3 BSD Unix System, 1989
 
  - B. Kernighan, R. Pike, The Unix Programming Environment, 
    Prentice Hall, 1984

##
                      LINKS
                      =====

      - https://www.tuhs.org 
        The Unix Heritage Society

      - gopher://republic.circumlunar.space/0/~katolaz/phlog/20190901_unix_50.txt
        Unix gets 50 -- 50 links and pointers

      - https://github.com/dspinellis/unix-history-repo
        Research Unix historic source repository     

      - https://github.com/robohack/ucb-csrg-bsd 
        BSD historic source repository
   
      - https://museo.freaknet.org
        Museo dell'Informatica Funzionante 
        Freaknet, Palazzolo Acreide (SR)

      - https://www.verdebinario.org
        Verdebinario e Museo Interattivo di Archeologia Informatica 


